/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007 by TAKAGI Nobuhisa
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */
#undef  BEGIN_KERNEL_CHK
#undef  END_KERNEL_CHK
#undef  KERNEL_CHK_SIZEOF
#undef  KERNEL_CHK_OFFSETOF
#undef  KERNEL_CHK_VALUEOF

#ifdef IMPLEMENT_KERNEL_CHK

#define BEGIN_KERNEL_CHK            ofile_ << "\t0x12345678,\n\tTKERNEL_PRID,\n"  \
                                              "\tCHAR_BIT,\n" \
                                              "\tCHAR_MAX,\n" \
                                              "\tSCHAR_MAX,\n" \
                                              "\tSHRT_MAX,\n" \
                                              "\tINT_MAX,\n" \
                                              "\tLONG_MAX,\n"
#define END_KERNEL_CHK              ;
#define KERNEL_CHK_SIZEOF( sym )    KERNEL_CHK_SIZEOF_( sym )
#define KERNEL_CHK_SIZEOF_( sym )   "\tsizeof(" #sym "),\n"
#define KERNEL_CHK_OFFSETOF( type, member )  "\toffsetof(" #type ", " #member "),\n"
#define KERNEL_CHK_VALUEOF( expr )  "\t" #expr ",\n"

#else

#define BEGIN_KERNEL_CHK            enum { magic_number, TKERNEL_PRID, \
                                           valueof_CHAR_BIT, \
                                           valueof_CHAR_MAX, \
                                           valueof_SCHAR_MAX, \
                                           valueof_SHRT_MAX, \
                                           valueof_INT_MAX, \
                                           valueof_LONG_MAX,
#define END_KERNEL_CHK              kernel_chk_table_size };
#define KERNEL_CHK_SIZEOF( sym )    sizeof_##sym,
#define KERNEL_CHK_OFFSETOF( type, member )  offsetof_##type##_##member,
#define KERNEL_CHK_VALUEOF( expr )  valueof_##expr,

#endif
