/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2008 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: target_config.c 696 2007-12-25 04:42:33Z honda $
 */

/*
 *  ^[QbgˑW[iAPSH2Apj
 */

#include "kernel_impl.h"
#include <sil.h>
#include "pdic\sh\sh_scif.h"
#include "apsh2a.h"

#ifdef ROM_BOOT
/*
 *  ROMɁCDZNṼTCY0ƁCBZNVPZNV
 *  ɔzu邽߁CDZNṼTCY0ɂȂ߂̃_~[
 *  `D
 */
static uint32_t __dummy = 1;
#endif

/*
 *  ^[Qbgˑ̏
 */
void
target_initialize(void)
{
    /*
     *  vZbTˑ̏
     */
    prc_initialize();
}

/*
 *  ^[Qbgˑ̏I
 */
void
target_exit(void)
{
    /*
     *  vZbTˑ̏I
     */
    prc_terminate();

    /*
     *  Jˑ̏I
     */
    apsh2a_exit();

    /*
     * ɂ͗Ȃ
     */
    while(1);
}

/*
 *  VXeO̒჌xo͂̂߂̕o
 */
void
target_fput_log(char_t c)
{
    if (c == '\n') {
        sh_scif_pol_putc('\r', TARGET_PUTC_PORTID);
    }
    sh_scif_pol_putc(c, TARGET_PUTC_PORTID);
}
