/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2008 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2008 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/*
 *		vZbTˑW[iSH7262pj
 *
 *  ̃CN[ht@ĆCtarget_config.hi܂́CCN
 *  [ht@Cĵ݂CN[hD̃t@C
 *  ڃCN[hĂ͂ȂȂD
 */

#ifndef TOPPERS_SH7262_CONFIG_H
#define TOPPERS_SH7262_CONFIG_H

/*
 *  oNWX^gp邩
 */

#define USE_BANKED_REG


/*
 * ݃nhԍɊւ`
 */ 
#define TMIN_INHNO 64U
#define TMAX_INHNO 312U
#define TNUM_INH   (312U - 64U + 1U)

/*
 * ݔԍɊւ`
 */ 
#define TMIN_INTNO 64U
#define TMAX_INTNO 312U
#define TNUM_INT   (312U - 64U + 1U)

/*
 *  ݗvC̗Dxݒ背WX^̐ݒ
 */
#define IPR_INFO_TBL_DATA   \
    {IPR01, 12U}, /*  64 IRQ0 */ \
    {IPR01,  8U}, /*  65 IRQ1 */ \
    {IPR01,  4U}, /*  66 IRQ2 */ \
    {IPR01,  0U}, /*  67 IRQ3 */ \
    {IPR02, 12U}, /*  68 IRQ4 */ \
    {IPR02,  8U}, /*  69 IRQ5 */ \
    {IPR02,  4U}, /*  70 IRQ6 */ \
    {IPR02,  0U}, /*  71 IRQ7 */ \
\
    {0U, 0U},     /*  72 */ \
    {0U, 0U},     /*  73 */ \
    {0U, 0U},     /*  74 */ \
    {0U, 0U},     /*  75 */ \
    {0U, 0U},     /*  76 */ \
    {0U, 0U},     /*  77 */ \
    {0U, 0U},     /*  78 */ \
    {0U, 0U},     /*  79 */ \
\
    {IPR05, 12U}, /*  80 PINT0 */ \
    {IPR05, 12U}, /*  81 PINT1 */ \
    {IPR05, 12U}, /*  82 PINT2 */ \
    {IPR05, 12U}, /*  83 PINT3 */ \
    {IPR05, 12U}, /*  84 PINT4 */ \
    {IPR05, 12U}, /*  85 PINT5 */ \
    {IPR05, 12U}, /*  86 PINT6 */ \
    {IPR05, 12U}, /*  87 PINT7 */ \
\
    {0U, 0U},     /*  88 */ \
    {0U, 0U},     /*  89 */ \
    {0U, 0U},     /*  90 */ \
    {0U, 0U},     /*  91 */ \
    {0U, 0U},     /*  92 */ \
    {0U, 0U},     /*  93 */ \
    {0U, 0U},     /*  94 */ \
    {0U, 0U},     /*  95 */ \
    {0U, 0U},     /*  96 */ \
    {0U, 0U},     /*  97 */ \
    {0U, 0U},     /*  98 */ \
    {0U, 0U},     /*  99 */ \
    {0U, 0U},     /* 100 */ \
    {0U, 0U},     /* 101 */ \
    {0U, 0U},     /* 102 */ \
    {0U, 0U},     /* 103 */ \
    {0U, 0U},     /* 104 */ \
    {0U, 0U},     /* 105 */ \
    {0U, 0U},     /* 106 */ \
    {0U, 0U},     /* 107 */ \
\
    {IPR06, 12U}, /* 108 DMAC0_TEI */ \
    {IPR06, 12U}, /* 109 DMAC0_HEI */ \
\
    {0U, 0U},     /* 110 */ \
    {0U, 0U},     /* 111 */ \
\
    {IPR06,  8U}, /* 112 DMAC1_TEI */ \
    {IPR06,  8U}, /* 113 DMAC1_HEI */ \
\
    {0U, 0U},     /* 114 */ \
    {0U, 0U},     /* 115 */ \
\
    {IPR06,  4U}, /* 116 DMAC2_TEI */ \
    {IPR06,  4U}, /* 117 DMAC2_HEI */ \
\
    {0U, 0U},     /* 118 */ \
    {0U, 0U},     /* 119 */ \
\
    {IPR06,  0U}, /* 120 DMAC3_TEI */ \
    {IPR06,  0U}, /* 121 DMAC3_HEI */ \
\
    {0U, 0U},     /* 122 */ \
    {0U, 0U},     /* 123 */ \
\
    {IPR07, 12U}, /* 124 DMAC4_TEI */ \
    {IPR07, 12U}, /* 125 DMAC4_HEI */ \
\
    {0U, 0U},     /* 126 */ \
    {0U, 0U},     /* 127 */ \
\
    {IPR07,  8U}, /* 128 DMAC5_TEI */ \
    {IPR07,  8U}, /* 129 DMAC5_HEI */ \
\
    {0U, 0U},     /* 130 */ \
    {0U, 0U},     /* 131 */ \
\
    {IPR07,  4U}, /* 132 DMAC6_TEI */ \
    {IPR07,  4U}, /* 133 DMAC6_HEI */ \
\
    {0U, 0U},     /* 134 */ \
    {0U, 0U},     /* 135 */ \
\
    {IPR07,  0U}, /* 136 DMAC7_TEI */ \
    {IPR07,  0U}, /* 137 DMAC7_HEI */ \
\
    {0U, 0U},     /* 138 */ \
    {0U, 0U},     /* 139 */ \
\
    {IPR08,  12U}, /* 140 DMAC8_TEI */ \
    {IPR08,  12U}, /* 141 DMAC8_HEI */ \
\
    {0U, 0U},     /* 142 */ \
    {0U, 0U},     /* 143 */ \
\
    {IPR08,   8U}, /* 144 DMAC9_TEI */ \
    {IPR08,   8U}, /* 145 DMAC9_HEI */ \
\
    {0U, 0U},     /* 146 */ \
    {0U, 0U},     /* 147 */ \
\
    {IPR08,   4U}, /* 148 DMAC10_TEI */ \
    {IPR08,   4U}, /* 149 DMAC10_HEI */ \
\
    {0U, 0U},     /* 150 */ \
    {0U, 0U},     /* 151 */ \
\
    {IPR08,   0U}, /* 152 DMAC11_TEI */ \
    {IPR08,   0U}, /* 153 DMAC11_HEI */ \
\
    {0U, 0U},     /* 154 */ \
    {0U, 0U},     /* 155 */ \
\
    {IPR09,  12U}, /* 156 DMAC12_TEI */ \
    {IPR09,  12U}, /* 157 DMAC12_HEI */ \
\
    {0U, 0U},     /* 158 */ \
    {0U, 0U},     /* 159 */ \
\
    {IPR09,   8U}, /* 160 DMAC13_TEI */ \
    {IPR09,   8U}, /* 161 DMAC13_HEI */ \
\
    {0U, 0U},     /* 162 */ \
    {0U, 0U},     /* 163 */ \
\
    {IPR09,   4U}, /* 164 DMAC14_TEI */ \
    {IPR09,   4U}, /* 165 DMAC14_HEI */ \
\
    {0U, 0U},     /* 166 */ \
    {0U, 0U},     /* 167 */ \
\
    {IPR09,   0U}, /* 168 DMAC15_TEI */ \
    {IPR09,   0U}, /* 169 DMAC15_HEI */ \
\
    {0U, 0U},  /* 170 USB */ \
\
	{IPR10,  8U},  /* 171 VIVSYNCJ */ \
	{IPR10,  8U},  /* 172 VBUFERR */  \
	{IPR10,  8U},  /* 173 VIFIELDE */ \
	{IPR10,  8U},  /* 174 VOLINE */   \
\
    {IPR10,  4U},  /* 175 CMI0 */ \
    {IPR10,  0U},  /* 176 CMI1 */ \
\
    {IPR11, 12U},  /* 177 CMI */ \
    {IPR11,  8U},  /* 178 ITI */ \
\
    {IPR11,  4U},  /* 179 MTU0_TGIA */ \
    {IPR11,  4U},  /* 180 MTU0_TGIB */ \
    {IPR11,  4U},  /* 181 MTU0_TGIC */ \
    {IPR11,  4U},  /* 182 MTU0_TGID */ \
    {IPR11,  0U},  /* 183 MTU0_TGIV */ \
    {IPR11,  0U},  /* 184 MTU0_TGIE */ \
    {IPR11,  0U},  /* 185 MTU0_TGIF */ \
\
    {IPR12, 12U},  /* 186 MTU1_TGIA */ \
    {IPR12, 12U},  /* 187 MTU1_TGIB */ \
    {IPR12,  8U},  /* 188 MTU1_TGIV */ \
    {IPR12,  8U},  /* 189 MTU1_TGIU */ \
\
    {IPR12,  4U},  /* 190 MTU2_TGIA */ \
    {IPR12,  4U},  /* 191 MTU2_TGIB */ \
    {IPR12,  0U},  /* 192 MTU2_TGIV */ \
    {IPR12,  0U},  /* 193 MTU2_TGIU */ \
\
    {IPR13, 12U},  /* 194 MTU3_TGIA */ \
    {IPR13, 12U},  /* 195 MTU3_TGIB */ \
    {IPR13, 12U},  /* 196 MTU3_TGIC */ \
    {IPR13, 12U},  /* 197 MTU3_TGID */ \
    {IPR13,  8U},  /* 198 MTU3_TGIV */ \
\
    {IPR13,  4U},  /* 199 MTU4_TGIA */ \
    {IPR13,  4U},  /* 200 MTU4_TGIB */ \
    {IPR13,  4U},  /* 201 MTU4_TGIC */ \
    {IPR13,  4U},  /* 202 MTU4_TGID */ \
    {IPR13,  0U},  /* 203 MTU4_TGIV */ \
\
	{IPR14, 12U},  /* 204 MCPT1 */ \
	{IPR14,  8U},  /* 205 MCPT2 */ \
\
    {IPR14,  4U},  /* 206 ADI */ \
\
	{IPR15, 12U},  /* 207 SSI_SSIF0 */   \
	{IPR15, 12U},  /* 208 SSI_SSIRXI0 */ \
	{IPR15, 12U},  /* 209 SSI_SSITXI0 */ \
	{IPR15,  8U},  /* 210 SSI_SSII1 */   \
	{IPR15,  8U},  /* 211 SSI_SSIRTI1 */ \
	{IPR15,  4U},  /* 212 SSI_SSII2 */   \
	{IPR15,  4U},  /* 213 SSI_SSIRTI2 */ \
	{IPR15,  0U},  /* 214 SSI_SSII3 */   \
	{IPR15,  0U},  /* 215 SSI_SSIRTI3 */ \
\
	{IPR16, 12U},  /* 216 SPDIFI */  \
\
    {IPR16,  8U},  /* 217 IIC3_STPI0 */ \
    {IPR16,  8U},  /* 218 IIC3_NAKI0 */ \
    {IPR16,  8U},  /* 219 IIC3_RXI0 */ \
    {IPR16,  8U},  /* 220 IIC3_TXI0 */ \
    {IPR16,  8U},  /* 221 IIC3_TEI0 */ \
\
    {IPR16,  4U},  /* 222 IIC3_STPI1 */ \
    {IPR16,  4U},  /* 223 IIC3_NAKI1 */ \
    {IPR16,  4U},  /* 224 IIC3_RXI1 */ \
    {IPR16,  4U},  /* 225 IIC3_TXI1 */ \
    {IPR16,  4U},  /* 226 IIC3_TEI1 */ \
\
    {IPR16,  0U},  /* 227 IIC3_STPI2 */ \
    {IPR16,  0U},  /* 228 IIC3_NAKI2 */ \
    {IPR16,  0U},  /* 229 IIC3_RXI2 */ \
    {IPR16,  0U},  /* 230 IIC3_TXI2 */ \
    {IPR16,  0U},  /* 231 IIC3_TEI2 */ \
\
    {IPR17, 12U},  /* 232 SCIF0_BRI */ \
    {IPR17, 12U},  /* 233 SCIF0_ERI */ \
    {IPR17, 12U},  /* 234 SCIF0_RXI */ \
    {IPR17, 12U},  /* 235 SCIF0_TXI */ \
\
    {IPR17,  8U},  /* 236 SCIF1_BRI */ \
    {IPR17,  8U},  /* 237 SCIF1_ERI */ \
    {IPR17,  8U},  /* 238 SCIF1_RXI */ \
    {IPR17,  8U},  /* 239 SCIF1_TXI */ \
\
    {IPR17,  4U},  /* 240 SCIF2_BRI */ \
    {IPR17,  4U},  /* 241 SCIF2_ERI */ \
    {IPR17,  4U},  /* 242 SCIF2_RXI */ \
    {IPR17,  4U},  /* 243 SCIF2_TXI */ \
\
    {IPR17,  0U},  /* 244 SCIF3_BRI */ \
    {IPR17,  0U},  /* 245 SCIF3_ERI */ \
    {IPR17,  0U},  /* 246 SCIF3_RXI */ \
    {IPR17,  0U},  /* 247 SCIF3_TXI */ \
\
    {IPR18, 12U},  /* 248 SCIF4_BRI */ \
    {IPR18, 12U},  /* 249 SCIF4_ERI */ \
    {IPR18, 12U},  /* 250 SCIF4_RXI */ \
    {IPR18, 12U},  /* 251 SCIF4_TXI */ \
\
    {IPR18,  8U},  /* 252 SCIF5_BRI */ \
    {IPR18,  8U},  /* 253 SCIF5_ERI */ \
    {IPR18,  8U},  /* 254 SCIF5_RXI */ \
    {IPR18,  8U},  /* 255 SCIF5_TXI */ \
\
    {IPR18,  4U},  /* 256 SCIF6_BRI */ \
    {IPR18,  4U},  /* 257 SCIF6_ERI */ \
    {IPR18,  4U},  /* 258 SCIF6_RXI */ \
    {IPR18,  4U},  /* 259 SCIF6_TXI */ \
\
    {IPR18,  0U},  /* 260 SCIF7_BRI */ \
    {IPR18,  0U},  /* 261 SCIF7_ERI */ \
    {IPR18,  0U},  /* 262 SCIF7_RXI */ \
    {IPR18,  0U},  /* 263 SCIF7_TXI */ \
\
	{IPR19, 12U},  /* 264 SICFI */     \
\
	{IPR19,  4U},  /* 265 SP0_SPEI */  \
	{IPR19,  4U},  /* 266 SP0_SPRI */  \
	{IPR19,  4U},  /* 267 SP0_SPTI */  \
\
	{IPR19,  0U},  /* 268 SP1_SPEI */  \
	{IPR19,  0U},  /* 269 SP1_SPRI */  \
	{IPR19,  0U},  /* 270 SP1_SPTI */  \
\
	{IPR20, 12U},  /* 271 CEN0_ERS */  \
	{IPR20, 12U},  /* 272 CEN0_OVR */  \
	{IPR20, 12U},  /* 273 CEN0_RM0 */  \
	{IPR20, 12U},  /* 274 CEN0_RM1 */  \
	{IPR20, 12U},  /* 275 CEN0_SLE */  \
\
	{IPR20,  8U},  /* 276 CEN0_ERS */  \
	{IPR20,  8U},  /* 277 CEN0_OVR */  \
	{IPR20,  8U},  /* 278 CEN0_RM0 */  \
	{IPR20,  8U},  /* 279 CEN0_RM1 */  \
	{IPR20,  8U},  /* 280 CEN0_SLE */  \
\
	{IPR20,  4U},  /* 281 IEB */       \
\
	{IPR20,  0U},  /* 282 CDD_ISY */ \
	{IPR20,  0U},  /* 283 CDD_IERR */ \
	{IPR20,  0U},  /* 284 CDD_ITARG */ \
	{IPR20,  0U},  /* 285 CDD_ISEC */ \
	{IPR20,  0U},  /* 286 CDD_IBUF */ \
	{IPR20,  0U},  /* 287 CDD_IREADY */ \
\
    {IPR21, 12U},  /* 288 FLCTL_FLSTEI */ \
    {IPR21, 12U},  /* 289 FLCTL_FLTENDI */ \
    {IPR21, 12U},  /* 290 FLCTL_FLTREQ0I */ \
    {IPR21, 12U},  /* 291 FLCTL_FLTREQ1I */ \
\
    {IPR21,  8U},  /* 292 SDHI_SDHI3 */ \
    {IPR21,  8U},  /* 293 SDHI_SDHI0 */ \
    {IPR21,  8U},  /* 294 SDHI_SDHI1 */ \
\
    {0U, 0U},     /* 295 */ \
\
    {IPR21,  4U},  /* 296 RTC_ARM */ \
    {IPR21,  4U},  /* 297 RTC_PRD */ \
    {IPR21,  4U},  /* 298 RTC_CUP */ \
\
    {IPR22, 12U},  /* 299 SRC0_OVF */ \
	{IPR22, 12U},  /* 300 SRC0_UDF */ \
	{IPR22, 12U},  /* 301 SRC0_CEF */ \
    {IPR22, 12U},  /* 302 SRC0_ODFI */ \
    {IPR22, 12U},  /* 303 SRC0_IDEI */ \
\
    {IPR22,  8U},  /* 304 SRC1_OVF */ \
    {IPR22,  8U},  /* 305 SRC1_UDF */ \
    {IPR22,  8U},  /* 306 SRC1_CEF */ \
    {IPR22,  8U},  /* 307 SRC1_ODFI */ \
    {IPR22,  8U},  /* 308 SRC1_IDEI */ \
\
    {0U, 0U},     /* 309 */ \
\
    {IPR22,  0U},  /* 310 DCUEI */ \
    {IPR22,  0U},  /* 311 OFFI */ \
    {IPR22,  0U}  /* 312 IFEI */
	

#ifndef TOPPERS_MACRO_ONLY
#pragma inline (init_irc)
/*
 * IRC̏
 */
Inline void
init_irc(void)
{
    sil_wrh_mem((void*)ICR0, 0x0000U);
    sil_wrh_mem((void*)ICR1, 0x0000U);
    sil_wrh_mem((void*)ICR2, 0x0000U);
    
#ifdef USE_BANKED_REG
    /* WX^oNgpCI[o[t[Ő֎~ */    
    sil_wrh_mem((void*)IBCR, 0xfffeU);
    sil_wrh_mem((void*)IBNR, 0x4000U);
#else
    /* WX^oNgp֎~ */    
    sil_wrh_mem((void*)IBCR, 0x0000U);
    sil_wrh_mem((void*)IBNR, 0x0000U);
#endif /* USE_BANKED_REG */    
    sil_wrh_mem((void*)IPR01, 0x0000U);
    sil_wrh_mem((void*)IPR02, 0x0000U);
    sil_wrh_mem((void*)IPR05, 0x0000U);
    sil_wrh_mem((void*)IPR06, 0x0000U);
    sil_wrh_mem((void*)IPR07, 0x0000U);
    sil_wrh_mem((void*)IPR08, 0x0000U);
    sil_wrh_mem((void*)IPR09, 0x0000U);
    sil_wrh_mem((void*)IPR10, 0xF000U);
    sil_wrh_mem((void*)IPR11, 0x0000U);
    sil_wrh_mem((void*)IPR12, 0x0000U);
    sil_wrh_mem((void*)IPR13, 0x0000U);
    sil_wrh_mem((void*)IPR14, 0x0000U);
    sil_wrh_mem((void*)IPR15, 0x0000U);
    sil_wrh_mem((void*)IPR16, 0x0000U);
    sil_wrh_mem((void*)IPR17, 0x0000U);
	sil_wrh_mem((void*)IPR18, 0x0000U);
    sil_wrh_mem((void*)IPR19, 0x0000U);
    sil_wrh_mem((void*)IPR20, 0x0000U);
	sil_wrh_mem((void*)IPR21, 0x0000U); 
	sil_wrh_mem((void*)IPR22, 0x0000U);
}

#endif /* TOPPERS_MACRO_ONLY */


/*
 *  vZbTˑW[iSH2Apj
 */
#include "sh12a_hew\sh2a_config.h"

#endif /* TOPPERS_SH7262_CONFIG_H */
