#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>

#include "kernel_cfg.h"
#include "led_onboard.h"
#include "syssvc/serial.h"

/* Rg[WX^ */
#define PCCR2	((volatile unsigned short int *)(0xFFFE384A))
/* IOWX^ */
#define PCIOR0	((volatile unsigned short int *)(0xFFFE3852))
/* f[^WX^ */
#define PCDR0	((volatile unsigned short int *)(0xFFFE3856))

/*
 *  {[hLED ONAOFF ؑւ^XN
 */
void bled_task(intptr_t exinf)
{
	while(1){
		slp_tsk();  /* ̃^XNx~Ԃɂ */
		
		/* LED ONAOFF ؑւ */
		if((*PCDR0 & 0x0100) == 0x0100){
			/* LED_ */
			*PCDR0 = *PCDR0 & 0xFEFF;
		}else{
			/* LED */
			*PCDR0 = *PCDR0 | 0x0100;	
		}
	}

	ext_tsk();
}

/*
 *  C^XN
 */
void main_task(intptr_t exinf)
{
	/* PC8ƂĎgp */
	*PCCR2 = *PCCR2 & 0xFFF0;		
	/* o͂ƂĎgp */
	*PCIOR0= *PCIOR0 | 0x0100;		
	/* LED */
	*PCDR0 = *PCDR0 | 0x0100;		
	
	/* BLED_TASK̋N */
	act_tsk(BLED_TASK);

	/* C[v */
	do {
		dly_tsk(1000);
		wup_tsk(BLED_TASK);
	} while (1);

	assert(0);
}